# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, m, s) = map(int, fi.readline().strip().split())
if 2 > n or n > 200000:
	sys.exit('N out of range')
if n - 1 > m or m > 4 * n / 3:
	sys.exit('M out of range')
if 1 > s or s > n:
	sys.exit('S out of range')
fo.write('{0} {1} {2}\n'.format(n, m, s))

t = set()
for i in range(m):
	(a, b) = map(int, fi.readline().strip().split())
	if 1 > a or a > n:
		sys.exit('A[{0}] out of range'.format(1 + i))
	if 1 > b or b > n:
		sys.exit('B[{0}] out of range'.format(1 + i))
	if a == b:
		sys.exit('A[{0}] = B[{0}]'.format(1 + i, 1 + i))
	if (min(a, b), max(a, b)) in t:
		sys.exit('A[{0}] and B[{0}] already connected'.format(1 + i, 1 + i))
	t.add((min(a, b), max(a, b)))
	fo.write('{0} {1}\n'.format(a, b))

g = [[] for i in range(1 + n)]
for (a, b) in t:
	g[a].append(b)
	g[b].append(a)

v = [0 for i in range(1 + n)]
p = [0 for i in range(1 + n)]
d = [0 for i in range(1 + n)]
s = [1] # DFS from vertex 1
while len(s) > 0:
	i = s.pop()
	if v[i] == 0:
		v[i] = 1
		for j in g[i]:
			if v[j] == 0:
				p[j] = i
				d[j] = d[i] + 1
				s.append(j)
if sum(v) != n:
	sys.exit('Road graph not connected')

c = [0 for i in range(1 + n)]
for (a, b) in t:
	if p[a] != b and p[b] != a:
		while d[a] > d[b]:
			c[a] += 1
			a = p[a]
		while d[b] > d[a]:
			c[b] += 1
			b = p[b]
		while a != b:
			c[a] += 1
			a = p[a]
			c[b] += 1
			b = p[b]
		c[a] += 1
if max(c) > 1:
	sys.exit('Road graph not vertex cactus')

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if m == n - 1:
		print('subtask 1')
	elif m < n - 1 + 100:
		print('subtask 2')
	else:
		print('subtask 3')
