# -*- coding: utf8 -*-

# 2018-03-18 programmeerimisvõistlus
# Ülesanne: RINGTEED
# Autor: Ahto Truu
# Testitud: Python 2.7 / CygWin; Python 3.6 / CygWin

# Leiab ühe sügavuti läbimisega kõik ringid.
# Marsruudi lõpud võivad olla ainult kaht liiki väljakud:
# - sellised, millesse siseneb ainult üks tänav;
# - sellised, mis on mingil ringil stardile lähima väljaku naabrid ja
#   millelt ei lähe tänavat sellelt ringilt välja.

import sys

# Globaalsed muutujad graafi esitamiseks
# g[i] - tipu i naabrite loend
# v[i] - tipu i olek graafi läbimisel
# r[i] - tipu i ringi number, kui tipp on ringil

# Ringide tuvastamine sügavuti läbimisega
def otsi(i, k):
	v[i] = 1
	for j in g[i]:
		if v[j] == 0:
			t = otsi(j, i)
			if t > 0:
				r[i] = t
		elif j != k:
			if r[i] == 0:
				r[i] = j
	if r[i] == i:
		return 0
	else:
		return r[i]

with open('ringsis.txt', 'r') as sis:
	n, m, s = [int(i) for i in sis.readline().strip().split()]
	g = [[] for i in range(n + 1)]
	v = [0 for i in range(n + 1)]
	r = [0 for i in range(n + 1)]
	for i in range(m):
		a, b = [int(i) for i in sis.readline().strip().split()]
		g[a].append(b)
		g[b].append(a)

sys.setrecursionlimit(n + 10)
otsi(s, 0)

k = 0
for i in range(n + 1):
	if len(g[i]) == 1 and i != s:
		k += 1
	elif len(g[i]) == 2 and r[i] in g[i]:
		k += 1

with open('ringval.txt', 'w') as val:
	val.write('{0}\n'.format(k))
