#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

int answerTask = 0;

vector<vector<int> > g;
int n, m, startVertex;

vector<int> colorCycle, poolVertex;
vector<bool> useVertex;
vector<bool> openCycle;
int countCycles = 0;


void readData() {
	freopen("ringsis.txt", "r", stdin);
	scanf("%d %d %d\n", &n, &m, &startVertex);
	--startVertex;
	g.resize(n, vector<int>());
	for (int i = 0; i < m; ++i) {
		int leftV, rightV;
		scanf("%d %d\n", &leftV, &rightV);
		--leftV, --rightV;
		g[leftV].push_back(rightV);
		g[rightV].push_back(leftV);
	}
}

void findCycle(int nextVertex) {
	vector<int> curCycle;
	while (poolVertex[poolVertex.size() - 1] != nextVertex) {
		int indexVertex = poolVertex[poolVertex.size() - 1];
		curCycle.push_back(indexVertex);
		poolVertex.pop_back();
	}
	curCycle.push_back(nextVertex);
	++countCycles;
	for (int i = 0; i < curCycle.size(); ++i) {
		colorCycle[curCycle[i]] = countCycles;
	}
}

void dfs(int v, int p) {
	useVertex[v] = true;
	poolVertex.push_back(v);
	for (int i = 0; i < g[v].size(); ++i) {
		int nextVertex = g[v][i];
		if (nextVertex == p) {
			continue;
		}
		if (useVertex[nextVertex]) {
			if (colorCycle[nextVertex] != 0) {
				continue;
			}
			else {
				findCycle(nextVertex);
			}
		}
		else {
			dfs(nextVertex, v);
		}
	}
	if (poolVertex.size() > 0 && poolVertex[poolVertex.size() - 1] == v) {
		poolVertex.pop_back();
	}
}

void dfs_for_calculate_answer(int v) {
	if (colorCycle[v] != 0) {
		if (openCycle[colorCycle[v]] == false) {
			openCycle[colorCycle[v]] = true;
			if (colorCycle[v] != colorCycle[startVertex]) {
				for (int ind = 0; ind < g[v].size(); ++ind) {
					int next = g[v][ind];
					if (colorCycle[next] == colorCycle[v]) {
						if (g[next].size() == 2) {
							++answerTask;
						}
					}
				}
			}
		}
	}
	useVertex[v] = true;
	for (int i = 0; i < g[v].size(); ++i) {
		int next = g[v][i];
		if (useVertex[next]) {
			continue;
		}
		dfs_for_calculate_answer(next);
	}
}

void solveTask() {
	colorCycle.resize(n, 0);
	useVertex.resize(n, false);
	dfs(0, 0);

	for (int i = 0; i < n; ++i) {
		if (g[i].size() == 1 && i != startVertex) {
			++answerTask;
		}
	}

	if (colorCycle[startVertex] != 0) {
		for (int ind = 0; ind < g[startVertex].size(); ++ind) {
			int next = g[startVertex][ind];
			if (colorCycle[next] != colorCycle[startVertex]) continue;
			if (g[next].size() == 2) {
				++answerTask;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		useVertex[i] = false;
	}
	openCycle.resize(countCycles + 1, false);
	dfs_for_calculate_answer(startVertex);
}

void printAnswer() {
	freopen("ringval.txt", "w", stdout);
	printf("%d\n", answerTask);
}

int main(){
	readData();
	solveTask();
	printAnswer();
	return 0;
}
